//SpiroGrapheTourbillon_201f.js
//Une extension du script "spirograph.jsx" de Jongware
// 21.04.12 / Hans Haesler, Chtelard 52, CH-1018 Lausanne / <hsa@ringier.ch>
//DESCRIPTION:Dessine un objet dcoratif et geomtrique

// activer l'affichage des dialogues
app.scriptPreferences.userInteractionLevel = UserInteractionLevels.interactWithAll;

// mmoriser la version de l'application
var appVers = (app.version[0])*1;

// dfinir les noms des nuances fixes
altColor   = "* next swatch *";
noColor    = "[None]";
regisColor = "[Registration]";
paperColor = "[Paper]";
blackColor = "[Black]";

// mmoriser la langue du programme
var curLang = (app.locale)*1;

// prparer les noms des nuances (en FR et DE)
if (curLang   == 1279477362) { // = franais
	altColor     = "* nuance suivante *";
	noColor      = "[Sans]";
	regisColor   = "[Registration]";
	paperColor   = "[Papier]";
	blackColor   = "[Noir]";
	if (appVers  == 4) {
		noColor    = "[Aucun]";
		regisColor = "[Registration]";
	}
}
else if (curLang == 1279477613) { // = allemand
	altColor	   = "* nchstes Farbfeld *";
	noColor      = "[Ohne]";
	regisColor   = "[Passermarken]";
	paperColor   = "[Papier]";
	blackColor   = "[Schwarz]";
	if (appVers == 4) {
		noColor    = "[Keine]";
		regisColor = "[Passkreuze]";
	}
}

// la partie principale du script
if (app.documents.length != 0) {
	if (app.activeWindow.constructor.name == "LayoutWindow") {
		var curDoc = app.documents[0];
		// dresser une liste des nuances
		allSwatches = curDoc.swatches;
		// appeler la fonction qui lit les prfrences mmorises
		var allPrefs = getPrefs();
		if (allPrefs != "") {
			var prefVal = allPrefs.split("\n");
			var out1  = prefVal[0]*1;
			var out2  = prefVal[1]*1;
			var inn1  = prefVal[2]*1;
			var thck  = prefVal[3]*1;
			var rpet  = prefVal[4]*1;
			var bName = prefVal[5];
			if      (bName == "Black") { bName = blackColor; }
			else if (bName == "Paper") { bName = paperColor; }
			else if (bName == "Registration") { bName = regisColor; }
			else if (bName == "None") { bName = noColor; }
			var bgrT  = prefVal[6]*1;
			var ck0   = false;
			var eoFll = prefVal[7];
			if (eoFll == "true") {
				ck0 = true;
			}
			var sName = prefVal[8];
			if      (sName == "Black") { sName = blackColor; }
			else if (sName == "Paper") { sName = paperColor; }
			else if (sName == "Registration") { sName = regisColor; }
			else if (sName == "None") { sName = noColor; }
			var strT  = prefVal[9]*1;
			var strW  = prefVal[10]*1;
			var alig  = prefVal[11];
			var ck1 = 1;
			var ck2 = 0;
			var ck3 = 0;
			if (alig == "1") {
				ck1 = 0;
				ck2 = 1;
			}
			else if (alig == "2") {
				ck1 = 0;
				ck3 = 1;
			}
		}
		else {
			// utiliser les valeurs par dfaut 
			// quand le fichier des prfrences n'existe pas
			var out1 =    80;
			var out2 =    80;
			var inn1 =    17;
			var thck =    50;
			var rpet =     1;
			var bgrT =    70;
			var ck0  = false;
			var strT =   100;
			var strW =   0.5;
			var ck1  =     1;
			var ck2  =     0;
			var ck3  =     0;
			var bName = noColor;
			var sName = blackColor;
		}
		
		// appeler les fonctions qui prparent les listes des couleurs
		var bgrColor = getBgrColorList(bName);
		var bgrCol   = bgrColor[0];
		var bInd     = bgrColor[1];
		var strColor = getStrColorList(sName);
		var strCol   = strColor[0];
		var sInd     = strColor[1];
		
		// mmoriser les units de mesure
		// si ce n'est pas 2053991795 (= millimtres), modifier  millimtres
		hM = curDoc.viewPreferences.horizontalMeasurementUnits;
		vM = curDoc.viewPreferences.verticalMeasurementUnits;
		if (hM != 2053991795) {
			curDoc.viewPreferences.horizontalMeasurementUnits = MeasurementUnits.millimeters;
		}
		if (vM != 2053991795) {
			curDoc.viewPreferences.verticalMeasurementUnits = MeasurementUnits.millimeters;
		}
		
		// mettre l'origine des repres  "Page"
		var rO = curDoc.viewPreferences.rulerOrigin;
		if (rO != 1380143215) {
			curDoc.viewPreferences.rulerOrigin = RulerOrigin.pageOrigin;
		}

		// mmoriser le point zro
		var zP = curDoc.zeroPoint; 
		
		// appeler la fonction qui affiche le dialogue
		var anArray = displayDialog(out1, out2, inn1, thck, rpet, bgrCol, bInd, bgrT, ck0, strCol, sInd, strT, strW, ck1, ck2, ck3);
		var out1    = anArray[0];
		var out2    = anArray[1];
		var inn1    = anArray[2];
		var thck    = anArray[3];
		var reps    = anArray[4];
		var bColor  = anArray[5];
		var bgrT    = anArray[6];
		var eoFill  = anArray[7];
		var sColor  = anArray[8];
		var strT    = anArray[9];
		var strW    = anArray[10];
		var strA    = anArray[11];
		
		// appeler la fonction qui dessine l'objet spirographe
		drawSpiro(out1, out2, inn1, thck, reps, bColor, bgrT, eoFill, sColor, strT, strW, strA);
		
		// restaurer le point zro
		curDoc.zeroPoint = zP; 
		
		// restaurer l'origine des rgles (si ncessaire)
		if (rO != 1380143215) {
			curDoc.viewPreferences.rulerOrigin = rO;
		}
		
		// restaurer les units de mesure (si ncessaire)
		if (hM != 2053991795) {
			curDoc.viewPreferences.horizontalMeasurementUnits = hM;
		}
		if (vM != 2053991795) {
			curDoc.viewPreferences.verticalMeasurementUnits = vM;
		}
		// passer le mode de l'cran  "Aperu"
		if (appVers > 4) {
			app.activeWindow.screenMode = ScreenModeOptions.PREVIEW_TO_PAGE;
		}
	}
}
else {
	alert ("Ouvrir un document, s.v.p.", "Stop");
}


///////////// LES FONCTIONS ///////////////////////////////////////

// la fonction qui prpare les informations
function getPrefs() {
	var allPrefs = "";
	// lire le fichier contenant les rglages mmoriss
	if ($.os.slice(0,7) == "Windows") {
		var tempFolder = Folder.temp;
		var f = File(tempFolder + "/SpiroGraph201.txt");
	}
	else {
		var f = new File("~/Library/Preferences/SpiroGraph201.txt");
	}
	var fileIsOpen = f.open("r");
	if (fileIsOpen) {
		try {
			allPrefs = f.read();
			f.close();
		}
		catch (e) {
			try {
				f.close();
			}
			catch (e) {
			}
		}
	}
	return allPrefs;
}

// la fonction qui prpare la liste des couleurs pour le fond
function getBgrColorList(bName) {	
	// vrifier si la couleur mmorise existe
	if (bName != noColor && bName != regisColor && bName != paperColor && bName != blackColor) {
		try {
			curDoc.swatches.itemByName(bName).name;
		}
		catch (e) {
			bName = blackColor;
		}
	}
	
	// assembler la liste des couleurs;
	// renommer "None", "Paper", "Black" et "Registration";
	// relever la position de la couleur mmorise
	var bgrColorList = new Array();
	for (var i=0; i<allSwatches.length; i++) {
		cName = allSwatches.item(i).name;
		if (cName == "None") {
			cName = noColor;
		}
		else if (cName == "Paper") {
			cName = paperColor;
		}
		else if (cName == "Black") {
			cName = blackColor;
		}
		else if (cName == "Registration") {
			cName = regisColor;
		}
		if (bName == cName) {
			bIndex = i;
		}
		bgrColorList.push(cName);
	}
	return [bgrColorList, bIndex];
}

// la fonction qui prpare la liste des couleurs du contour
function getStrColorList(sName) {
	// vrifier si la couleur mmorise existe
	if (sName != altColor && sName != noColor && sName != regisColor && sName != paperColor && sName != blackColor) {
		try {
			curDoc.swatches.itemByName(sName).name;
		}
		catch (e) {
			sName = blackColor;
		}
	}
	
	// assembler la liste des couleurs;
	// renommer "None", "Registration", "Paper" et "Black";
	// relever la position de la couleur mmorise
	strColorList = new Array(altColor);
	for (var i=0; i<allSwatches.length; i++) {
		cName = allSwatches.item(i).name;
		if (cName == "None") {
			cName = noColor;
		}
		else if (cName == "Paper") {
			cName = paperColor;
		}
		else if (cName == "Black") {
			cName = blackColor;
		}
		else if (cName == "Registration") {
			cName = regisColor;
		}
		if (sName == cName) {
			sIndex = i+1;
		}
		strColorList.push(cName);
	}
	if (sName == altColor) {
		sIndex = 0;
	}
	return [strColorList, sIndex];
}

// prparer et afficher le dialogue
function displayDialog(out1, out2, inn1, thck, rpet, bgrCol, bInd, bgrT, ck0, strCol, sInd, strT, strW, ck1, ck2, ck3) {
	try {
		app.dialogs.everyItem().destroy();
	}
	catch (e) {
	}
	var labelWidth = 120;
	var fieldWidth =  40;
	var aDialog = app.dialogs.add({name:"Tourbillon spirographe"});
	with (aDialog.dialogColumns.add()) {
		with (dialogRows.add()) {
			with (dialogColumns.add()) {
				staticTexts.add({staticLabel:"Rayon extrieur v", minWidth:labelWidth});
			}
			with (dialogColumns.add()) {
				var outer1Field = realEditboxes.add({editValue:out1, minWidth:fieldWidth});
			}
			with (dialogColumns.add()) {
				staticTexts.add({staticLabel:"mm"});
			}
		}
		with (dialogRows.add()) {
			with (dialogColumns.add()) {
				staticTexts.add({staticLabel:"Rayon extrieur h", minWidth:labelWidth});
			}
			with (dialogColumns.add()) {
				var outer2Field = integerEditboxes.add({editValue:out2, minWidth:fieldWidth});
			}
			with (dialogColumns.add()) {
				staticTexts.add({staticLabel:"mm"});
			}
		}
		with (dialogRows.add()) {
			with (dialogColumns.add()) {
				staticTexts.add({staticLabel:"Rayon intrieur", minWidth:labelWidth});
			}
			with (dialogColumns.add()) {
				var innerField = integerEditboxes.add({editValue:inn1,minWidth:fieldWidth});
			}
			with (dialogColumns.add()) {
				staticTexts.add({staticLabel:"mm"});
			}
		}
		with (dialogRows.add()) {
			with (dialogColumns.add()) {
				staticTexts.add({staticLabel:"Epaisseur", minWidth:labelWidth});
			}
			with (dialogColumns.add()) {
				var thickField = integerEditboxes.add({editValue:thck, minWidth:fieldWidth});
			}
			with (dialogColumns.add()) {
				staticTexts.add({staticLabel:"mm"});
			}
		}
		with (dialogRows.add()) {
			with (dialogColumns.add()) {
				staticTexts.add({staticLabel:"Nombre d'objets", minWidth:labelWidth});
			}
			with (dialogColumns.add()) {
				var repsField = integerEditboxes.add({editValue:rpet, minWidth:fieldWidth});
			}
		}
		with (borderPanels.add()) {
			with (dialogColumns.add()) {
				with (dialogRows.add()) {
					staticTexts.add({staticLabel:"Le FOND de l'objet", minWidth:labelWidth-10});
					staticTexts.add({staticLabel:" "});
				}
				var bgrColor = dropdowns.add({stringList:bgrCol, selectedIndex:bInd, minWidth:130});
				with (dialogRows.add()) {
					staticTexts.add({staticLabel:"La teinte", minWidth:labelWidth-10});
					var bgrTint = realEditboxes.add({editValue:bgrT, minimumValue:0, maximumValue:100, minWidth:fieldWidth});
					staticTexts.add({staticLabel:"%", minWidth:12});
				}
			}
		}
		var evenOddCheckbox = checkboxControls.add({staticLabel:"Remplissage altern", checkedState:ck0});
		with (borderPanels.add()) {
			with (dialogColumns.add()) {
				with (dialogRows.add()) {
					staticTexts.add({staticLabel:"Le CONTOUR de l'objet", minWidth:labelWidth-10});
					staticTexts.add({staticLabel:" "});
				}
				var strColor = dropdowns.add({stringList:strCol, selectedIndex:sInd, minWidth:130});
				with (dialogRows.add()) {
					staticTexts.add({staticLabel:"La teinte", minWidth:labelWidth-10});
					var strTint = realEditboxes.add({editValue:strT, minimumValue:0, maximumValue:100, minWidth:fieldWidth});
					staticTexts.add({staticLabel:"%", minWidth:12});
				}
				with (dialogRows.add()) {
					staticTexts.add({staticLabel:"L'paisseur", minWidth:labelWidth-10});
					var strWeight = realEditboxes.add({editValue:strW, minimumValue:0, maximumValue:5, minWidth:fieldWidth});
					staticTexts.add({staticLabel:"pt", minWidth:12});
				}
				with (dialogRows.add()) {
					staticTexts.add({staticLabel:"L'alignement", minWidth:labelWidth-10});
					with(aligButtons = radiobuttonGroups.add()){
						radiobuttonControls.add({staticLabel:"centrer", checkedState:ck1});
						radiobuttonControls.add({staticLabel:"intrieur", checkedState:ck2});
						radiobuttonControls.add({staticLabel:"extrieur", checkedState:ck3});
					}
				}
			}
		}
	}
	if (aDialog.show() == true) {
		var out1 = outer1Field.editValue;
		var out2 = outer2Field.editValue;
		var inn1 = innerField.editValue;
		if (inn1 == 0) { inn1 = 1; }
		var thck = thickField.editValue;
		var reps = repsField.editValue;
		if (reps < 1) { reps = 1; }
		bgrIndex = bgrColor.selectedIndex;
		bColor   = curDoc.swatches[bgrIndex].name;
		if      (bColor == blackColor) { bColor = "Black"; }
		else if (bColor == paperColor) { bColor = "Paper"; }
		else if (bColor == regisColor) { bColor = "Registration"; }
		else if (bColor == noColor)    { bColor = "None"; }
		bgrT = bgrTint.editValue;
		var ck0 = evenOddCheckbox.checkedState;
		strIndex = strColor.selectedIndex;
		sColor = strColorList[strIndex];
		if      (sColor == blackColor) { sColor = "Black"; }
		else if (sColor == paperColor) { sColor = "Paper"; }
		else if (sColor == regisColor) { sColor = "Registration"; }
		else if (sColor == noColor)    { sColor = "None"; }
		strT = strTint.editValue;
		strW = strWeight.editValue;
		var aligDec = aligButtons.selectedButton;
		if (aligDec == 0) {
			strA = 1936998723; // centrer
		}
		else if (aligDec == 1) {
			strA = 1936998729; // intrieur
		}
		else if (aligDec == 2) {
			strA = 1936998735; // extrieur
		}
		aDialog.destroy();
		var prefsList = new Array (out1, out2, inn1, thck, reps, bColor, bgrT, ck0, sColor, strT, strW, aligDec);
		var prefString = prefsList.join("\n");
		writeResult(prefString);
		return [out1, out2, inn1, thck, reps, bColor, bgrT, ck0, sColor, strT, strW, strA];
	}
	else{
		aDialog.destroy();
		exit();
	}
}

// crire le rsultat dans un fichier
function writeResult(curPrefs) {
	if ($.os.slice(0,7) == "Windows") {
		var tempFolder = Folder.temp;
		var f = File(tempFolder + "/SpiroGraph201.txt");
	}
	else {
		var f = File("~/Library/Preferences/SpiroGraph201.txt");
	}
	var fileIsOpen = f.open("w");
	if (fileIsOpen) {
		try {
			f.write(curPrefs);
			f.close();
		}
		catch (e) {
			try {
				f.close();
			}
			catch (e) {
			}
		}
	}
}

// cette fonction dessine l'objet spirographe
function drawSpiro(out1, out2, inn1, thck, reps, bColor, bgrT, eoFill, sColor, strT, strW, strA) {
	// la planche actuelle et la page slectionn
	var curSpread = app.activeWindow.activeSpread;
	var curPage   = app.activeWindow.activePage;
	
	aa = Math.max(out1, out2);
	bb = inn1;
	while (Math.round(aa) != aa || Math.round(bb) != bb) {
		aa *= 10;
		bb *= 10;
	}
	// couper la valeur pour "Epaisseur" en deux
	defThck = thck/2;
	
	// aller chercher le plus grand dnominateur commun
	nLoop = bb/greatestCommonFactor(aa,bb);
	dif = (360*nLoop)/reps;
	
	// prparer la liste si "* nuance prochaine *"
	var altColors = false;
	if (sColor == altColor) {
		altColors = true;
		var tmpColorList = new Array ();
		if (reps > 1) {
			var nCol = strColorList.length;
			if (nCol > 5) {
				for (var i=1; i<nCol; i++) {
					var curCol = strColorList[i];
					if (curCol != noColor && curCol != regisColor && curCol != paperColor && curCol != blackColor) {
						tmpColorList.push(curCol);
					}
				}
			}
			else {
				tmpColorList.push("Black");
			}
		}
		else {
			tmpColorList.push("Black");
		}
		var nColors = tmpColorList.length;
		if (reps > nColors) {
			var altStrColors = new Array ();
			var ctr = 0;
			for (r=0; r<reps; r++) {
				altStrColors.push(tmpColorList[ctr]);
				ctr++;
				if (ctr == nColors) {
					ctr = 0;
				}
			}
		}
		else {
			var altStrColors = tmpColorList;
		}
	}
	
	// la dimension de la page
	pW = app.activeDocument.documentPreferences.pageWidth;
	pH = app.activeDocument.documentPreferences.pageHeight;
	// le centre
	if (pH > pW) {
		app.activeDocument.zeroPoint = [pW/2, pW/2];
	}
	else {
		app.activeDocument.zeroPoint = [pW/2, pH/2];
	}
	
	// une boucle  travers le nombre d'objets
	for (r=0; r<reps; r++) {
		newLine = null;
		path = [];
		if ((out1/inn1) < 5.3) {
			for (t=0; t<=nLoop*360; t++) {
			
				x = (out2 - inn1) * Math.cos(t*Math.PI/180) + defThck * Math.cos ((t+(r*dif))*((out1 - inn1)/inn1)*Math.PI/180);
				y = (out1 - inn1) * Math.sin(t*Math.PI/180) - defThck * Math.sin ((t+(r*dif))*((out1 - inn1)/inn1)*Math.PI/180);
			
				path.push ([x,y]);
				if (path.length > 10000) {
					if (newLine == null) {
						newLine = curPage.graphicLines.add().paths[0];
					} 
					else {
						newLine = newLine.parent.paths.add();
					}
					newLine.entirePath = path;
					path = [ [x,y] ];
				}
			}
		}
		else {
			for (t=0; t<=nLoop*360; t+=0.5) {
			
				x = (out2 - inn1) * Math.cos(t*Math.PI/180) + defThck * Math.cos ((t+(r*dif))*((out1 - inn1)/inn1)*Math.PI/180);
				y = (out1 - inn1) * Math.sin(t*Math.PI/180) - defThck * Math.sin ((t+(r*dif))*((out1 - inn1)/inn1)*Math.PI/180);
			
				path.push ([x,y]);
				if (path.length > 10000) {
					if (newLine == null) {
						newLine = curPage.graphicLines.add().paths[0];
					} 
					else {
						newLine = newLine.parent.paths.add();
					}
					newLine.entirePath = path;
					path = [ [x,y] ];
				}
			}
		}
		if (path.length > 1) {
			if (newLine == null) {
				newLine = curPage.graphicLines.add().paths[0];
			} 
			else {
				newLine = newLine.parent.paths.add();
			}
			newLine.entirePath = path;
		}
		if (reps == 1) {
			if (altColors) {
				sColor = altStrColors[0];
			}
			if (eoFill == true) {
				// dupliquer l'objet s'il y a "Remplissage altern"...
				var newPolygon = newLine.parent.duplicate();
				// ... et runir les deux
				try {
					newLine.parent.addPath(newPolygon);
				}
				catch (e) {
				}
				// appliquer les attributs
				try {
					newPolygon.properties = {fillColor:bColor, fillTint:bgrT, strokeWeight:strW, strokeColor:sColor, strokeTint:strT, strokeAlignment:strA, strokeType:app.activeDocument.strokeStyles.item("$ID/Solid")};
					// crire les rglages Spiro dans l'tiquette de l'objet
					newPolygon.label = "Rayon extrieur v: " + out1 + " mm\rRayon extrieur h: " + out2 + " mm\rRayon intrieur: " + inn1 + " mm\rEpaisseur: " + thck + " mm";
				}
				catch (e) {
					alert ("Dsol. Cela ne marche pas avec ces valeurs.");
					exit();
				}
			}
			else {
				// appliquer les attributs
				try {
					newLine.parent.properties = {fillColor:bColor, fillTint:bgrT, strokeWeight:strW, strokeWeight:strW, strokeColor:sColor, strokeTint:strT, strokeAlignment:strA, strokeType:app.activeDocument.strokeStyles.item("$ID/Solid")};
					// crire les rglages Spiro dans l'tiquette de l'objet
					newLine.parent.label = "Rayon extrieur v: " + out1 + " mm\rRayon extrieur h: " + out2 + " mm\rRayon intrieur: " + inn1 + " mm\rEpaisseur: " + thck + " mm";
				}
				catch (e) {
					alert ("Dsol. Cela ne marche pas avec ces valeurs.");
					exit();
				}
			}
		}
		else {
			if (altColors) {
				sColor = altStrColors[r];
			}
			// appliquer les attributs
			try {
				newLine.parent.properties = {fillColor:bColor, fillTint:bgrT, strokeWeight:strW, strokeColor:sColor, strokeTint:strT, strokeAlignment:strA, strokeType:app.activeDocument.strokeStyles.item("$ID/Solid")};
				// crire les rglages Spiro dans l'tiquette de l'objet
				newLine.parent.label = "Rayon extrieur v: " + out1 + " mm\rRayon extrieur h: " + out2 + " mm\rIRayon intrieur: " + inn1 + " mm\rEpaisseur: " + thck + " mm";
			}
			catch (e) {
				alert ("Dsol. Cela ne marche pas avec ces valeurs.");
				exit();
			}
		}
	}
}

// la fonction qui tablit le plus grand dnominateur commun
function greatestCommonFactor (x,y) {
	while (y != 0) {
		w = x % y;
		x = y;
		y = w;
	}
	return x;
}